﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace ParticleEffectsDemo
{
    public class ParticleGenerator<T> where T : new()
    {
        const int DEFAULT_SIZE = 10;
        Queue<T> particles;

        public ParticleGenerator()
        {
            particles = new Queue<T>();
            CreateParticles(DEFAULT_SIZE);
        }

        private void CreateParticles(int n)
        {
            for (int i = 0; i < n; i++)
                particles.Enqueue(new T());
        }

        public T GetParticle()
        {
            if (particles.Count == 0)
            {
                CreateParticles(DEFAULT_SIZE);
            }

            return particles.Dequeue();
        }

        public void ReturnParticle(T p)
        {
            particles.Enqueue(p);
        }
    }
}
